-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxilliary"
M.relevantDevice = nil

local DEPLOY_SPOILER_SPEED = 37.5

local function init(jbeamData)
	electrics.values["zennol"] = 0.1
	electrics.values["zennor"] = 0.1
	electrics.values["zennollastangle"] = 0
	electrics.values["zennorlastangle"] = 0
	electrics.values["zennobrake"] = 0
	electrics.values["zennorlastangle"] = 0
	electrics.values["zennog"] = 0
end

local function updateGFX(dt) -- ms
	local isBraking = electrics.values.brake_input > 0
	local isGoingFast = electrics.values.airspeed > DEPLOY_SPOILER_SPEED

	-- spoiler deployment:
	local deployAmount = 0

	if electrics.values.airspeed > 10 then

		-- when braking, just deploy by amount of braking
		if isBraking then
			deployAmount = deployAmount + electrics.values.brake_input * 0.5
		end

		-- if going fast, deploy just a little
		if isGoingFast then
			deployAmount = deployAmount + 0.2
		end

		-- send it:
		electrics.values["zennobrake"] = deployAmount

		if sensors.gx > 5 then
			electrics.values["zennog"] = sensors.gx * 0.01
		end

		electrics.values["zennol"] =
			electrics.values["zennollastangle"] + electrics.values["zennobrake"] + (electrics.values["zennorlastangle"] * 0.1) +
			0.1
		electrics.values["zennor"] =
			electrics.values["zennorlastangle"] + electrics.values["zennobrake"] + (electrics.values["zennollastangle"] * 0.1) +
			0.1

	else
		init()
	end
end

M.init = init
M.initLastStage = initLastStage
M.reset = init
M.updateGFX = updateGFX

return M
